#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2400seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 2400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2400seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven24004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven24004xi = {
                1:'-1011x-1775y1259z',
                2:'-1028x-2017y794z',
                3:'-1095x-1709y1279z',
                4:'-1128x-1954y816z',
                5:'-1176x-1639y1299z',
                6:'-121x-2317y610z',
                7:'-1224x-1885y839z',
                8:'-1226x-2062y5z',
                9:'-1252x-1565y1319z',
                10:'-1316x-1812y861z',
                11:'-1323x-1487y1339z',
                12:'-1332x-1995y29z',
                13:'-1390x-1406y1359z',
                14:'-1404x-1734y883z',
                15:'-1435x-1922y53z',
                16:'-1451x-1322y1379z',
                17:'-1487x-1651y906z',
                18:'-1508x-1236y1399z',
                19:'-1533x-1844y77z',
                20:'-1559x-1147y1418z',
                21:'-1564x-1564y928z',
                22:'-159x-1199y2072z',
                23:'-1605x-1056y1437z',
                24:'-1627x-1761y101z',
                25:'-1637x-1474y950z',
                26:'-1646x-963y1456z',
                27:'-1681x-869y1475z',
                28:'-1705x-1380y972z',
                29:'-1710x-773y1494z',
                30:'-1716x-1672y125z',
                31:'-1734x-677y1513z',
                32:'-1753x-581y1532z',
                33:'-1766x-484y1550z',
                34:'-1767x-1283y994z',
                35:'-1774x-388y1568z',
                36:'-1800x-1579y149z',
                37:'-1823x-1184y1016z',
                38:'-1874x-1081y1037z',
                39:'-1879x-1482y173z',
                40:'-1918x-977y1059z',
                41:'-1953x-1380y197z',
                42:'-1957x-871y1080z',
                43:'-1990x-763y1102z',
                44:'-2016x-655y1123z',
                45:'-2020x-1275y221z',
                46:'-2037x-545y1144z',
                47:'-2052x-436y1165z',
                48:'-2060x-326y1186z',
                49:'-2062x-216y1207z',
                50:'-2082x-1166y245z',
                51:'-210x-2126y1091z',
                52:'-2138x-1055y269z',
                53:'-2188x-940y292z',
                54:'-218x-1169y2084z',
                55:'-2231x-823y316z',
                56:'-2268x-704y340z',
                57:'-2299x-584y364z',
                58:'-22x-23y2399z',
                59:'-23x-342y2375z',
                60:'-241x-2302y633z',
                61:'-274x-1135y2096z',
                62:'-320x-2101y1113z',
                63:'-327x-1099y2107z',
                64:'-34x-1250y2048z',
                65:'-361x-2279y656z',
                66:'-36x-43y2399z',
                67:'-377x-1061y2119z',
                68:'-38x-317y2378z',
                69:'-424x-1020y2130z',
                70:'-427x-2071y1134z',
                71:'-467x-977y2141z',
                72:'-478x-2251y679z',
                73:'-48x-64y2398z',
                74:'-507x-932y2152z',
                75:'-50x-291y2381z',
                76:'-532x-2034y1155z',
                77:'-544x-886y2162z',
                78:'-578x-838y2172z',
                79:'-58x-86y2397z',
                80:'-593x-2216y702z',
                81:'-5x-367y2371z',
                82:'-607x-790y2183z',
                83:'-60x-265y2384z',
                84:'-634x-1993y1176z',
                85:'-634x-740y2192z',
                86:'-657x-690y2202z',
                87:'-65x-110y2396z',
                88:'-671x-123y2300z',
                89:'-676x-640y2211z',
                90:'-67x-238y2387z',
                91:'-686x-163y2293z',
                92:'-691x-589y2221z',
                93:'-698x-206y2286z',
                94:'-6x-5y2399z',
                95:'-704x-538y2230z',
                96:'-706x-2175y725z',
                97:'-708x-249y2279z',
                98:'-712x-488y2238z',
                99:'-715x-295y2271z',
                100:'-718x-439y2247z',
                101:'-719x-342y2263z',
                102:'-71x-134y2395z',
                103:'-720x-390y2255z',
                104:'-72x-212y2389z',
                105:'-734x-1946y1197z',
                106:'-74x-160y2393z',
                107:'-74x-185y2391z',
                108:'-817x-2128y748z',
                109:'-830x-1893y1218z',
                110:'-917x-773y2078z',
                111:'-922x-1836y1238z',
                112:'-924x-2076y771z',
                113:'-927x-869y2152z',
                114:'-939x-711y2090z',
                115:'-958x-650y2102z',
                116:'-973x-588y2113z',
                117:'-983x-526y2124z',
                118:'-98x-1226y2060z',
                119:'-990x-465y2135z',
                120:'-993x-404y2146z',
                121:'-99x-2145y1070z',
                122:'0x-2327y587z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2400seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2400seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2400SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2400SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2400SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2400SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2400SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven24004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2400SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2400SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2400SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven24004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven24004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2400SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2400SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2400SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2400seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       